#!/usr/local/bin/ruby
#-*-Ruby-*-
# $Id: mhccat.cgi,v 1.3 2001-02-02 14:52:57+09 oharakun Exp oharakun $

require "web-mhc-conf"
require "web-mhc"
require "mhc-schedule"
require "mhc-date"
require "cgi"
require "kconv"

data = ''

$query = CGI::new

def error(str)
  print "Content-Type: text/plain\n\n"
  print str
  exit 1
end

date = $query['date'][0]

type = ($query['type'][0]) ? $query['type'][0] : 'html'

path = $query['path'][0]

error("Specify the schedule file.\n") unless (date && type && path)

path_regex = Regexp::compile(path + '$')

the_day = MhcDate::new(date)
sDB = MhcScheduleDB::new
sDB.search(the_day, the_day).each { |date, items|
  items.each { |sch|
    if sch.path =~ path_regex
      data << sch.dump
      break
    end
  }
}

if (type =~ /html/i)
  print "Content-Type: text/html\n"
else
  print "Content-Type: text/plain\n"
end
print "\n"

if (type =~ /html/i)

  print <<EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang=ja>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-2022-JP">
<title>schedule</title>
</head>

<body>
<pre>
EOT

  print Kconv::tojis(CGI::escapeHTML(Kconv::toeuc(data)))

  print <<EOT
</pre>
</body>
</html>
EOT

else
  while f.gets
    print
  end
end

f.close

exit 0
